float4x4 world;
float4x4 view_proj;
float4 light_dir;

#define SHADOW_FACTOR 3000

void vp_main (
        in float3 vertex : POSITION,
        out float4 light_dist_ : TEXCOORD0,
        out float4 for_rasteriser : POSITION

) {
        float3 vertex_ws = mul(world,float4(vertex,1)).xyz;
        light_dist_ = -dot(vertex_ws,light_dir.xyz);
        for_rasteriser = mul(view_proj,float4(vertex_ws,1));
}

void fp_main (
        in float4 light_dist_ : TEXCOORD0,
        out float4 pixel : COLOR
) {
        pixel.rgba = float4(light_dist_.z / SHADOW_FACTOR,0,0,1);
}

// vim: ts=8:sw=8:et
